<?xml version="1.0" encoding="utf-8" ?>
<doctrine-mapping
        xmlns="http://doctrine-project.org/schemas/orm/doctrine-mapping"
        xmlns:gedmo="http://gediminasm.org/schemas/orm/doctrine-extensions-mapping"
        xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
        xsi:schemaLocation="http://doctrine-project.org/schemas/orm/doctrine-mapping
                            https://raw.github.com/doctrine/doctrine2/master/doctrine-mapping.xsd">

    <entity name="App\Domain\Registry\Model\Treatment" table="registry_treatment">

        <id name="id" column="id" type="uuid"/>

        <field name="name" column="name"/>
        <field name="goal" column="goal" type="text" nullable="true"/>
        <field name="manager" column="manager" nullable="true"/>
        <field name="software" column="software" nullable="true"/>
        <field name="paperProcessing" column="paper_processing" type="boolean"/>
        <field name="legalBasis" column="legal_basis" type="json_array"/>
        <field name="legalBasisJustification" column="legal_basis_justification" type="text" nullable="true"/>
        <field name="observation" column="observation" type="text" nullable="true"/>
        <field name="concernedPeople" column="concerned_people" type="json_array"/>
        <field name="dataCategoryOther" column="data_category_other" type="text" nullable="true"/>
        <field name="dataOrigin" column="data_origin" nullable="true"/>
        <field name="recipientCategory" column="recipient_category" type="text" nullable="true"/>
        <field name="systematicMonitoring" column="systematic_monitoring" type="boolean"/>
        <field name="largeScaleCollection" column="large_scale_collection" type="boolean"/>
        <field name="vulnerablePeople" column="vulnerable_people" type="boolean"/>
        <field name="dataCrossing" column="data_crossing" type="boolean"/>
        <field name="authorizedPeople" column="authorized_people" nullable="true"/>
        <field name="active" column="active" type="boolean"/>
        <field name="completion" column="completion" type="integer"/>
        <field name="template" column="template" type="boolean"/>
        <field name="templateIdentifier" column="template_identifier" type="integer" nullable="true"/>

        <embedded name="delay" class="App\Domain\Registry\Model\Embeddable\Delay" column-prefix="delay_"/>
        <embedded name="securityAccessControl" class="App\Domain\Registry\Model\Embeddable\ComplexChoice" column-prefix="security_access_control_"/>
        <embedded name="securityTracability" class="App\Domain\Registry\Model\Embeddable\ComplexChoice" column-prefix="security_tracability_"/>
        <embedded name="securitySaving" class="App\Domain\Registry\Model\Embeddable\ComplexChoice" column-prefix="security_saving_"/>
        <embedded name="securityUpdate" class="App\Domain\Registry\Model\Embeddable\ComplexChoice" column-prefix="security_update_"/>
        <embedded name="securityOther" class="App\Domain\Registry\Model\Embeddable\ComplexChoice" column-prefix="security_other_"/>

        <many-to-many field="contractors" target-entity="App\Domain\Registry\Model\Contractor" inversed-by="treatments">
            <join-table name="treatment_contractor">
                <join-columns>
                    <join-column/>
                </join-columns>
                <inverse-join-columns>
                    <join-column/>
                </inverse-join-columns>
            </join-table>
            <order-by>
                <order-by-field name="name"/>
            </order-by>
        </many-to-many>
        <many-to-many field="dataCategories" target-entity="App\Domain\Registry\Model\TreatmentDataCategory">
            <join-table name="registry_assoc_treatment_data_category">
                <join-columns>
                    <join-column/>
                </join-columns>
                <inverse-join-columns>
                    <join-column referenced-column-name="code"/>
                </inverse-join-columns>
            </join-table>
            <order-by>
                <order-by-field name="position"/>
            </order-by>
        </many-to-many>
        <many-to-many field="proofs" target-entity="App\Domain\Registry\Model\Proof" mapped-by="treatments">
            <order-by>
                <order-by-field name="name"/>
            </order-by>
        </many-to-many>
        <many-to-one field="clonedFrom" target-entity="App\Domain\Registry\Model\Treatment" >
            <join-column on-delete="SET NULL" />
        </many-to-one>>

        <!-- Traits -->
        <many-to-one field="collectivity" target-entity="App\Domain\User\Model\Collectivity"/>
        <many-to-one field="creator" target-entity="App\Domain\User\Model\User"/>
        <field name="createdAt" column="created_at" type="datetime_immutable">
            <gedmo:timestampable on="create"/>
        </field>
        <field name="updatedAt" column="updated_at" type="datetime_immutable">
            <gedmo:timestampable on="update"/>
        </field>

    </entity>

</doctrine-mapping>
